/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.138 by edhill, Sun Dec 4 13:57:08 2005 UTC revision 1.146 by edhill, Fri Apr 7 02:53:55 2006 UTC
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 248  build_cyrus_makedepend()  { Line 256  build_cyrus_makedepend()  {
256      fi      fi
257  }  }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 535  Usage: "$0" [OPTIONS] Line 578  Usage: "$0" [OPTIONS]
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587      -ts | --ts      -ts | --ts
588            Produce timing information per timestep            Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s with PAPI per timestep
591        -foolad | --foolad
592              Fool the AD code generator
593        -papi | --papi
594              Performance analysis with PAPI
595        -hpmt | --hpmt
596              Performance analysis with the HPM Toolkit
597    
598        -gsl | --gsl
599              Use GSL to control floating point rounding and precision
600    
601      -mpi | --mpi      -mpi | --mpi
602            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
# Line 545  Usage: "$0" [OPTIONS] Line 605  Usage: "$0" [OPTIONS]
605            set to PATH. i.e. Include files from \$PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
606            from \$PATH/lib and use binaries from \$PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
607    
608        -es | --es | -embed-source | --embed-source
609              Embed a tarball containing the full source code
610              (including the Makefile, etc.) used to build the
611              executable [off by default]
612    
613      -bash NAME      -bash NAME
614            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
615    
# Line 950  NOOPTFLAGS= Line 1015  NOOPTFLAGS=
1015  MPI=  MPI=
1016  MPIPATH=  MPIPATH=
1017  TS=  TS=
1018    PAPIS=
1019    FOOLAD=
1020    PAPI=
1021    HPMT=
1022    GSL=
1023  HAVE_TEST_L=  HAVE_TEST_L=
1024    
1025  # DEFINES checked by test compilation or command-line  # DEFINES checked by test compilation or command-line
# Line 974  BASH= Line 1044  BASH=
1044  PWD=`pwd`  PWD=`pwd`
1045  test "x$MAKE" = x  &&  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1046  test "x$AWK" = x   &&  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1047    EMBED_SRC=
1048  THISHOST=`hostname`  THISHOST=`hostname`
1049  THISCWD=`pwd`  THISCWD=`pwd`
1050  THISDATE=`date`  THISDATE=`date`
# Line 1007  TAMC_EXTRA= Line 1078  TAMC_EXTRA=
1078    
1079  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1080  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1081  gm_s2="FC CPP IEEE TS MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PAPI HPMT GSL MPI JAM DUMPSTATE STANDARDDIRS"
1082    
1083  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1084  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 1189  for ac_option in "$@" ; do Line 1260  for ac_option in "$@" ; do
1260    
1261          -ts | --ts)          -ts | --ts)
1262              TS=true ;;              TS=true ;;
1263            -papis | --papis)
1264                PAPIS=true ;;
1265            -foolad | --foolad)
1266                FOOLAD=true ;;
1267            -papi | --papi)
1268                PAPI=true ;;
1269            -hpmt | --hpmt)
1270                HPMT=true ;;
1271    
1272            -gsl | --gsl)
1273                GSL=true ;;
1274    
1275          -mpi | --mpi)          -mpi | --mpi)
1276              MPI=true ;;              MPI=true ;;
# Line 1217  for ac_option in "$@" ; do Line 1299  for ac_option in "$@" ; do
1299          -ignoretime | -ignore_time | --ignoretime | --ignore_time)          -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1300              IGNORE_TIME="-DIGNORE_TIME" ;;              IGNORE_TIME="-DIGNORE_TIME" ;;
1301    
1302            -es | --es | -embed-source | --embed-source)
1303                EMBED_SRC=t ;;
1304    
1305          -*)          -*)
1306              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
1307              usage              usage
# Line 1432  fi Line 1517  fi
1517    
1518  if test ! "x$TS" = x ; then  if test ! "x$TS" = x ; then
1519        echo "  Turning on timing per timestep"        echo "  Turning on timing per timestep"
1520        DEFINES="$DEFINES -DTIME_PER_TIMESTEP"        if test ! "x$FOOLAD" = x ; then
1521                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1522          else
1523                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1524          fi
1525    fi
1526    if test ! "x$PAPIS" = x ; then
1527          echo "  Turning on PAPI flop summary per timestep"
1528          echo "  Please make sure PAPIINC, PAPILIB are defined"
1529          if test ! "x$FOOLAD" = x ; then
1530                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1531          else
1532                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1533          fi
1534          INCLUDES="$INCLUDES $PAPIINC"
1535          LIBS="$LIBS $PAPILIB"
1536    fi
1537    if test ! "x$PAPI" = x ; then
1538          if test ! "x$PAPIS" = x ; then
1539              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1540              echo "  Sticking with PAPI flop summary per timestep!"
1541          else
1542              echo "  Turning on performance analysis with PAPI"
1543              echo "  Please make sure PAPIINC, PAPILIB are defined"
1544              DEFINES="$DEFINES -DUSE_PAPI"
1545              INCLUDES="$INCLUDES $PAPIINC"
1546              LIBS="$LIBS $PAPILIB"
1547          fi
1548    fi
1549    if test ! "x$HPMT" = x ; then
1550          if test ! "x$PAPI" = x ; then
1551              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1552              echo "  Sticking with PAPI!"
1553          else
1554              echo "  Turning on performance analysis with the HPM Toolkit"
1555              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1556              DEFINES="$DEFINES -DUSE_LIBHPM"
1557              INCLUDES="$INCLUDES $HPMTINC"
1558              LIBS="$LIBS $HPMTLIB"
1559          fi
1560    fi
1561    if test ! "x$GSL" = x ; then
1562          echo "  Turning on use of GSL to control floating point calculations"
1563          echo "  Please make sure GSLINC, GSLLIB are defined"
1564          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1565          INCLUDES="$INCLUDES $GSLINC"
1566          LIBS="$LIBS $GSLLIB"
1567  fi  fi
1568    
1569  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
# Line 1503  if test "x$HAVE_CLOC" != x ; then Line 1634  if test "x$HAVE_CLOC" != x ; then
1634      echo "yes"      echo "yes"
1635  else  else
1636      echo "no"      echo "no"
1637        if test "x$EMBED_SRC" = xt ; then
1638            echo "    WARNING: you requested file embedding but it has"
1639            echo "      been disabled since C code cannot be called"
1640            EMBED_SRC=
1641        fi
1642  fi  fi
1643  rm -f genmake_t*  rm -f genmake_t*
1644    
# Line 1542  else Line 1678  else
1678  fi  fi
1679  DEFINES="$DEFINES $IGNORE_TIME"  DEFINES="$DEFINES $IGNORE_TIME"
1680    
1681    if test "x$EMBED_SRC" = xt ; then
1682        build_embed_encode
1683    fi
1684    if test "x$EMBED_SRC" = xt ; then
1685        ENABLE="$ENABLE embed_files"
1686    fi
1687    
1688    
1689  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
1690  printf "  Adding MODS directories:  "  printf "  Adding MODS directories:  "
1691  for d in $MODS ; do  for d in $MODS ; do
# Line 1993  for i in $INCLUDEDIRS ; do Line 2137  for i in $INCLUDEDIRS ; do
2137      fi      fi
2138  done  done
2139    
2140    if test ! "x$DIVA" = x ; then
2141        echo "  Creating the pseudo-MPI include directory"
2142        INCLUDES="-I./mpi_headers $INCLUDES"
2143        rm -rf ./mpi_headers
2144        mkdir -p ./mpi_headers
2145    
2146        if test "x$MPIINCLUDEDIR" = x ; then
2147            if test "x$MPIHOME" = x ; then
2148                MPIHOME='/usr'
2149            fi
2150            MPIINCLUDEDIR='$MPIHOME/include'
2151        fi
2152        
2153        if test -r $MPIINCLUDEDIR/mpif.h ; then
2154            for i in $MPI_HEADER_FILES; do
2155                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2156            done
2157    
2158            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2159        else
2160            echo " We cannot create a copy of mpif.h!"
2161            exit -1
2162        fi
2163    fi
2164    
2165  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2166  rm -rf .links.tmp  rm -rf .links.tmp
2167  mkdir .links.tmp  mkdir .links.tmp
2168    touch .links.tmp/foo
2169    if test ! -r ".links.tmp/foo" ; then
2170        echo
2171        echo "ERROR : something is wrong with your directory permissions or"
2172        echo "   your user file-creation mask (\"umask\") since creating a"
2173        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2174        echo "   not working.  Please try setting your umask to something"
2175        echo "   sane such as:"
2176        echo
2177        echo "      umask 0002"
2178        echo
2179        echo "   and please verify that you have the proper permissions for"
2180        echo "   creating sub-directories and then reading files created"
2181        echo "   within them."
2182        echo
2183        exit 1
2184    fi
2185    rm -f .links.tmp/foo
2186  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2187  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2188  printf 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
# Line 2014  for d in $alldirs ; do Line 2201  for d in $alldirs ; do
2201                  ignore_f=f                  ignore_f=f
2202                  case $d/$sf in                  case $d/$sf in
2203                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2204                            ignore_f=t
2205                          ;;                          ;;
2206                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2207                            ignore_f=t
2208                          ;;                          ;;
2209                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2210                            ignore_f=t
2211                          ;;                          ;;
2212                    ./BUILD_INFO.h)                    ./BUILD_INFO.h)
2213                            ignore_f=t
2214                            ;;
2215                      ./EMBEDDED_FILES.h)
2216                            ignore_f=t
2217                          ;;                          ;;
2218                    *)                    *)
2219                          #  For the local directory *ONLY*,                          #  For the local directory *ONLY*,
# Line 2132  DISABLED_PACKAGES = ${DISABLED_PACKAGES} Line 2326  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2326    
2327  # These files are created by Makefile  # These files are created by Makefile
2328  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2329  EOF  EOF
2330    
2331  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2332        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2333    else
2334        echo "EMBEDDED_FILES = " >>$MAKEFILE
2335    fi
2336    
2337    #  Note: figure out some way to add Hyades JAM libraries here
2338  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2339  # Unix ln (link)  # Unix ln (link)
2340  LN = ${LN}  LN = ${LN}
# Line 2198  rm -f ad_flow_files.inc Line 2396  rm -f ad_flow_files.inc
2396  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2397    
2398  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2399  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2400          @echo Creating \$@ ...          @echo Creating \$@ ...
2401          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2402  depend:  depend:
# Line 2232  CLEAN: Line 2430  CLEAN:
2430          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2431          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2432          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2433          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) *.txt STD* *diagnostics.log datetime
2434            -rm -rf mnc_test_*
2435    
2436  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2437  makefile:  makefile:
# Line 2260  test ! "x$THISUSER" = x && echo "      -echo Line 2459  test ! "x$THISUSER" = x && echo "      -echo
2459  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE  test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2460  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE  test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2461    
2462    if test "x$EMBED_SRC" = xt ; then
2463        cat >>$MAKEFILE <<EOF
2464    
2465    decode_files.o : EMBEDDED_FILES.h
2466    
2467    ##  \$(F77FILES)
2468    all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2469            @echo Creating \$@ ...
2470            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2471            -rm -f all_fF.tar.gz
2472            -gzip all_fF.tar
2473    
2474    EMBEDDED_FILES.h : all_fF.tar.gz
2475            @echo Creating \$@ ...
2476            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2477    
2478    EOF
2479    fi
2480    
2481  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2482    
2483  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
# Line 2276  cat >>$MAKEFILE <<EOF Line 2494  cat >>$MAKEFILE <<EOF
2494  .$FS90.o:  .$FS90.o:
2495          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2496  .c.o:  .c.o:
2497          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2498    
2499  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2500  .F.p:  .F.p:

Legend:
Removed from v.1.138  
changed lines
  Added in v.1.146

  ViewVC Help
Powered by ViewVC 1.1.22